/*---------------------------------------------------------------------
  All code is provided for EDUCATIONAL purposes ONLY. There is no
  warranty and no support.

  Module: nju6355.h
---------------------------------------------------------------------*/
#ifndef _NJU6355_H_
#define _NJU6355_H_

// Adjust the following depending on the clock speed in use

#define RTC_Delay_1us()		_delay_loop_1( 4 )      // 16MHz clock
#define RTC_Delay_10ms()	_delay_loop_2( 33300 )

// Ports connected to NJU6355

#define RTC_DATA_DDR      DDRC
#define RTC_DATA_DDR_BIT  DDC0
#define RTC_DATA_PORT_IN  PINC
#define RTC_DATA_PORT_OUT PORTC
#define RTC_DATA_BIT      PORTC0

#define RTC_CLK_PORT      PORTC
#define RTC_CLK_BIT       PORTC2

#define RTC_IO_PORT       PORTC
#define RTC_IO_BIT        PORTC1

#define RTC_CE_PORT       PORTC
#define RTC_CE_BIT        PORTC3

// Real Time Clock parameters

typedef struct _RTCparms
{
  uint8_t rtc_year;
  uint8_t rtc_month;
  uint8_t rtc_day;
  uint8_t rtc_dayweek;
  uint8_t rtc_hours;     // 0..23
  uint8_t rtc_mins;
  uint8_t rtc_secs;
}
RTCPARMS;

// Functions

void rtc_init( void );
void rtc_read( void );
void rtc_test( void );
void rtc_write( void );

#endif  //_NJU6355_H_
